---
- name: "Get info on docker host"
  tags: debug
  become: True
  become_user: root
  docker_host_info:
    containers: "yes"
  register: result
  vars:
    ansible_python_interpreter: "{{ cdd_remote_docker_python }}"

- name: "Validate if your particular runner is already deployed?"
  set_fact:
    runner_match: True
  with_subelements:
    - "{{ result.containers }}"
    - Names
  when:   (
           (result.host_info.ContainersRunning != '0')
           and
           (cdd_docker_runner_images[0].alias in item.1 )
           )

- name: "Register gitlab-runner as docker-executor, but only once"
  become: True
  become_user: root
  command: >
    docker run --rm -v "{{ cdd_docker_deployment_path }}/config:/etc/gitlab-runner:z" "{{ cdd_docker_runner_images[0].image }}" register
    --non-interactive
    --url "{{ cdd_gitlab_url }}"
    --registration-token "{{ lookup('env', 'RUNNER_REGISTRATION_TOKEN') }}"
    --executor "{{ cdd_runner_executor }}"
    --description "{{ cdd_runner_description }}"
    --tag-list "{{ cdd_runner_tag }}"
    --docker-image "{{ cdd_docker_python_custom_tt_image }}"
  when: not(
           (runner_match is defined and runner_match | bool == True)
           )
  vars:
    ansible_python_interpreter: "{{ cdd_remote_docker_python }}"

- name: "Start gitlab-runner as docker-executor only if not running"
  become: True
  become_user: root
  command: >
    docker run -d --name  "{{ cdd_docker_runner_images[0].alias }}"
    --restart always \
    -v "{{ cdd_docker_deployment_path }}/config:/etc/gitlab-runner:Z" \
    -v "{{ cdd_docker_socket_path }}/docker.sock:/var/run/docker.sock" \
    "{{ cdd_docker_runner_images[0].image }}":"{{ cdd_docker_runner_images[0].tag }}"
  when: not(
           (runner_match is defined and runner_match | bool == True)
           )
  vars:
    ansible_python_interpreter: "{{ cdd_remote_docker_python }}"